/*:
# **Kapitel 4.7**
## Einstieg
*/

/**
Klasse zur Beschreibung des Catwalks

- author: Klaus Reinold
- version: 1.0
 */
class Catwalk
{
//#-editable-code
    /** Die Leuchten */
    var leuchten: [Rechteck]
    /** Die zur Verfügung stehenden Farben */
    var farben: [String]
    /** Größe einer Leuchte */
    let breite = 40
    /** Anzahl der Leuchten */
    let spaltenanzahl = 10

    /**
    Der Konstruktor des Catwalks legt die Leuchten an
    */
    init()
    {
        leuchten = [Rechteck]()
        farben = Array<String>()
        var farbe: String
        farbe = "blau"
        for spalte in 0 ..< spaltenanzahl
        {
            leuchten.append(Rechteck())
            leuchten[spalte].GrößeSetzen(breite: breite, höhe: breite)
            leuchten[spalte].PositionSetzen(x: 40 + spalte * breite, y: 50)
            if farbe == "blau"
            {
                farbe = "rot"
            }
            else
            {
                farbe = "blau"
            }
            farben.append(farbe)
            FarbeSetzen(spalte: spalte, farbe: farbe)
        }
    }
    
    /**
    Setzt die angegebene Leuchte auf die gewünschte Farbe
	- parameters:
        - spalte: die Spaltennummer der Leuchte
        - farbe: die gewünschte Farbe
     */
    func FarbeSetzen(spalte: Int, farbe: String)
    {
        leuchten[spalte].FarbeSetzen(farbe: farbe)
        farben[spalte] = farbe
    }
    
    /**
    Gibt die Farbe der angegebene Leuchte
	- parameters:
        - spalte: die Spaltennummer der Leuchte
    - returns: die Farbe der gewünschten Leuchte
    */
    func FarbeGeben(spalte: Int) -> String
    {
        return farben[spalte]
    }
    
    /**
    Meldet die Anzahl der Leuchten
    - returns: Leuchtenanzahl
    */
    func SpaltenanzahlGeben() -> Int
    {
        return spaltenanzahl
    }
//#-end-editable-code
}

/**
Steuerung der Leuchten auf dem Dancefloor

- author: Klaus Reinold
- version: 1.0
 */
class CatwalkSteuerung: Figur
{
//#-editable-code
    /** Der Laufsteg */
    var laufsteg: Catwalk
    /** Der Zähler für die Farbensteuerung */
    var zähler: Int

    /**
    Legt den Laufsteg und den Zufallsgenerator an.
    */
    override init()
    {
        zähler = 0
        laufsteg = Catwalk()
        super.init()
        SichtbarkeitSetzen(sichtbar: false)
    }

    /**
    Lässt die Farben eine Spalte weiter laufen
    */
    override func AktionAusführen()
    {
        for spalte in 0 ..< laufsteg.SpaltenanzahlGeben() - 1
        {
            laufsteg.FarbeSetzen(spalte: spalte, farbe: laufsteg.FarbeGeben(spalte: spalte+1))
        }
        laufsteg.FarbeSetzen(spalte: laufsteg.SpaltenanzahlGeben()-1, farbe: NächsteFarbeGeben())
    }

    /**
    Bestimmt die nächste Farbe
    - returns: nächste Farbe
     */
    func NächsteFarbeGeben() -> String
    {
        var farbe: String
        switch zähler
        {
            case 0: farbe = "weiß"
            case 1: farbe = "rot"
            case 2: farbe = "grün"
            case 3: farbe = "blau"
            case 4: farbe = "gelb"
            case 5: farbe = "magenta"
            case 6: farbe = "cyan"
            case 7: farbe = "hellgelb"
            case 8: farbe = "hellgrün"
            case 9: farbe = "orange"
            case 10: farbe = "braun"
            case 11: farbe = "grau"
            default: farbe = "schwarz"
        }
        zähler = (zähler + 1) % 12
        return farbe
    }
//#-end-editable-code
}


/*:
Am John-von-Neumann-Gymnasium ist Abiturfeier! Die Schülerinnen und Schüler dürfen über einen Laufsteg
zur Schulleitung gehen, um sich die Zeugnisse abzuholen. Der Laufsteg besteht aus Glaswürfeln, die farbig
leuchten, mit durchlaufenden Farben oder in den Lieblingsfarben der jeweiligen Abiturienten.\
Das Technikteam hat vorab eine Simulation erstellt, um die Steuerung zu testen.\
a\
Erkunde, wie im Projekt Catwalk die Festlegung der nächsten Farbe realisiert ist.\
b\
Erprobe, wie eine alternative Lösung mit bedingten Anweisungen möglich wäre.\
c\
Erkunde, wie die Beleuchtung des Catwalks gesteuert wird.\
d\
Erprobe eine Beleuchtung in deinen Lieblingsfarben.*/
//#-editable-code
let c = CatwalkSteuerung()
//#-end-editable-code
