/*:
# **Kapitel 4.7**
## Aufgabe 8 Wachsender Baum
*/
/*:
Trickfilme wurden früher mühsam Bild für Bild von Hand gezeichnet. Moderne computeranimierte Trickfilme
nutzen bei ihrer Erstellung auch die Kontrollstrukturen, um Abläufe zu steuern und eine Abfolge von Bildern
zu erzeugen. Im Beispiel soll ein einfacher Trickfilm erzeugt werden, der einen Baum im Laufe der
Jahreszeiten und über die Jahre hinweg simuliert.\
a\
Experimentiere im vorgegebenen Projekt mit der Klasse BAUM und finde heraus,
was die gegebenen Methoden leisten.*/

/**
Beschreibt einen stilisierten Baum
 
- author: Klaus Reinold
- version: 1.0
 */
class Baum: Figur
{
    /** Der Himmel in der oberen Hälfte */
    var himmel: Rechteck
    /** Der Boden in der unteren Hälfte */
    var boden: Rechteck
    /** Der Baumstamm */
    var stamm: Rechteck
    /** Die Baumkrone */
    var krone: Kreis
    /** Die aktuelle Jahreszeit */
    var jahreszeit: String
    /** Die aktuelle Größe */
    var größe: Int

    /**
    Legt die benötigten Objekte an.
    */
    override init()
    {
        himmel = Rechteck()
        boden = Rechteck()
        stamm = Rechteck()
        krone = Kreis()
        größe = 100
        jahreszeit = ""
        super.init()
        himmel.FarbeSetzen(farbe: "blau")
        himmel.GrößeSetzen(breite: 800,höhe: 300)
        himmel.PositionSetzen(x: 0,y: 0)
        boden.FarbeSetzen(farbe: "grün")
        boden.GrößeSetzen(breite: 800,höhe: 300)
        boden.PositionSetzen(x: 0,y: 300)
        stamm.FarbeSetzen(farbe: "braun")
        stamm.GrößeSetzen(breite: 30,höhe: größe)
        stamm.PositionSetzen(x: 385,y: 380-größe)
        krone.PositionSetzen(x: 400,y: 300-(2*größe/3))
        krone.RadiusSetzen(radius: größe/2)
        FrühlingSetzen()
        SichtbarkeitSetzen(sichtbar: false)
    }
    
    /**
    tellt den Baum im Winter dar
    */
    func WinterSetzen()
    {
        jahreszeit = "Winter"
        krone.FarbeSetzen(farbe: "weiß")
    }
    
    /**
    Stellt den Baum im Frühling dar
    */
    func FrühlingSetzen()
    {
        jahreszeit = "Frühling"
        krone.FarbeSetzen(farbe: "hellgrün")
    }
    
    /**
    Stellt den Baum im Sommer dar
    */
    func SommerSetzen()
    {
        jahreszeit = "Sommer"
        krone.FarbeSetzen(farbe: "grün")
    }
    
    /**
    Stellt den Baum im Herbst dar
    */
    func HerbstSetzen()
    {
        jahreszeit = "Herbst"
        krone.FarbeSetzen(farbe: "orange")
    }
    
    /**
    Lässt den Baum wachsen
    */
    func Wachsen()
    {
        größe = größe+4
        stamm.GrößeSetzen(breite: 30,höhe: größe)
        stamm.PositionSetzen(x: 385,y: 380-größe)
        krone.PositionSetzen(x: 400,y: 300-(2*größe/3))
        krone.RadiusSetzen(radius: größe/2)
    }
    
    /**
    Der Baum tut nichts automatisch
    */
    override func AktionAusführen()
    {
        
    }
}
//#-editable-code
let b = Baum()
b.Wachsen()
//#-end-editable-code
/*:
b\
Erstelle eine Unterklasse WACHSENDERBAUM. Überschreibe die Methode *AktionAusführen* so,
dass der Baum mit Hilfe einer Mehrfachauswahl je nach aktueller Jahreszeit in die nachfolgende
Jahreszeit überführt wird. Im Frühling soll der Baum zudem wachsen.*/
//#-editable-code





//let bw=WachsenderBaum()
//#-end-editable-code
/*:
c\
Ergänze deinen Film um eigene Ideen (z. B. Baum kippt nach 200 Jahren um) oder erstelle
selbst einen eigenen Film. */
//#-editable-code



//#-end-editable-code
